#pragma comment(linker, "/STACK:256000000")
#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <sstream>
#include <cmath>
#include <cassert>
#include <memory.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forv(i, v) forn(i, v.size())
#define for1(i, n) for (int i = 1; i <= int(n); i++)

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

struct Point
{
	int x, y, z;
	Point() {};
	Point(int x, int y, int z): x(x), y(y), z(z) {};
};

struct Plane
{
	ll a, b, c, d;
	vector<int> idx;
};


inline bool operator<(const Point& p1, const Point& p2)
{
	if (p1.x != p2.x) return p1.x < p2.x;
	if (p1.y != p2.y) return p1.y < p2.y;
	return p1.z < p2.z;
}

inline bool operator==(const Point& p1, const Point& p2)
{
	return p1.x == p2.x && p1.y == p2.y && p1.z == p2.z;
}

inline Point operator-(const Point& p1, const Point& p2)
{
	return Point(p1.x - p2.x, p1.y - p2.y, p1.z - p2.z);
}

ll len2(Point& p)
{
	return p.x * p.x + p.y * p.y + p.z * p.z;
}

bool oneline(Point p1, Point p2, Point p3)
{
	p1 = p1 - p3;
	p2 = p2 - p3;
	ll scal = p1.x * p2.x + p1.y * p2.y + p1.z * p2.z;
	scal = scal * scal;
	return scal == len2(p1) * len2(p2);
}

ll det(int x1, int y1, int x2, int y2)
{
	return x1 * y2 - x2 * y1;
}

ll vol(Point p1, Point p2, Point p3, Point p4)
{
	p1 = p1 - p4;
	p2 = p2 - p4;
	p3 = p3 - p4;

	return p1.x * det(p2.y, p2.z, p3.y, p3.z) - p1.y * det(p2.x, p2.z, p3.x, p3.z) + p1.z * det(p2.x, p2.y, p3.x, p3.y);
}

const int NMAX = 3005;
int n;
Point p[NMAX];
bool used[NMAX];
bool usp[NMAX];

Point center;

int m = 0;
Plane sides[NMAX], sides1[NMAX];
int edges[NMAX][NMAX];

void addTriangle(int i1, int i2, int i3)
{
	Point p1 = p[i1]; 
	Point p2 = p[i2]; 
	Point p3 = p[i3];

	Plane s;

	s.a = det(p1.y - p2.y, p3.y - p1.y, p1.z - p2.z, p3.z - p1.z);
	s.b = det(p1.z - p2.z, p3.z - p1.z, p1.x - p2.x, p3.x - p1.x);
	s.c = det(p1.x - p2.x, p3.x - p1.x, p1.y - p2.y, p3.y - p1.y);
	s.d = -(s.a * p1.x + s.b * p1.y + s.c * p1.z);
	
	s.idx = vector<int>(3);
	s.idx[0] = i1; s.idx[1] = i2; s.idx[2] = i3;

	sort(all(s.idx));

 	if (s.a * center.x + s.b * center.y + s.c * center.z + 4 * s.d < 0)
 	{
 		s.a = -s.a;
 		s.b = -s.b;
 		s.c = -s.c;
 		s.d = -s.d;
 	}
 		
 	forn(i, 3)
 		forn(j, i)
 			edges[s.idx[i]][s.idx[j]]++;

	sides[m++] = s;	
}

void addPoint(int id)
{
	Point q = p[id];


	forn(i, m)
	{
		used[i] = false;
		if (sides[i].a * q.x + sides[i].b * q.y + sides[i].c * q.z + sides[i].d < 0)
		{
			forn(i1, 3)
				forn(i2, i1)
					edges[sides[i].idx[i1]][sides[i].idx[i2]]--;
			used[i] = true;
		}
		sides1[i] = sides[i];
	}


	int m1 = m;
	m = 0;

	forn(i, m1)
	{
		if (!used[i])
		{
			sides[m++] = sides1[i];
			continue;
		}

		forn(i1, 3)
			forn(i2, i1)
				if (edges[sides1[i].idx[i1]][sides1[i].idx[i2]] == 1)
					addTriangle(sides1[i].idx[i1], sides1[i].idx[i2], id);

	}
}
int main()
{
    freopen("input.txt", "rt", stdin);
    freopen("output.txt", "wt", stdout);

    cin >> n;
    forn(i, n) cin >> p[i].x >> p[i].y >> p[i].z;

    sort(p, p + n);
    n = int(unique(p, p + n) - p);

    assert(n >= 4);

    int i2 = 2;
    while (i2 < n && oneline(p[0], p[1], p[i2])) i2++;
    assert(i2 < n);

    int i3 = i2 + 1;
    while (i3 < n && vol(p[0], p[1], p[i2], p[i3]) == 0) i3++;

    assert(i3 < n);
    usp[0] = usp[1] = usp[i2] = usp[i3] = true;

    center.x = p[0].x + p[1].x + p[i2].x + p[i3].x;
    center.y = p[0].y + p[1].y + p[i2].y + p[i3].y;
    center.z = p[0].z + p[1].z + p[i2].z + p[i3].z;

    addTriangle(0, 1, i2);
    addTriangle(0, 1, i3);
    addTriangle(1, 2, i3);
    addTriangle(0, i2, i3);

    forn(i, n)
    {
    	if (usp[i]) continue;
    	addPoint(i);
    }

    ll V = 0;
    forn(i, m)
    {
    	V += abs(vol(p[0], p[sides[i].idx[0]], p[sides[i].idx[1]], p[sides[i].idx[2]]));
    }

     
    cout << V << endl;

    return 0;
}