#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <fstream>
#include <time.h>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second
#define uint unsigned int

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}


bool doubleEqual(double a, double b)
{
	return fabs(a - b) < 1e-9;
}

bool doubleLessOrEqual(double a, double b)
{
	return a < b || doubleEqual(a, b);
}

bool doubleLess(double a, double b)
{
	return a < b && !doubleEqual(a, b);
}

bool doubleGreaterOrEqual(double a, double b)
{
	return a > b || doubleEqual(a, b);
}

bool doubleGreate(double a, double b)
{
	return a > b && !doubleEqual(a, b);
}

double mySqrt(double a)
{
	if (doubleLess(a, 0))
	{
		throw "sqrt(-1)";
	}
	if (a < 0)
		return 0;
	return sqrt(a);
}


struct Point
{

public:
	double x, y;


	Point() : x(0), y(0) {}

	Point(double x, double y) : x(x), y(y) {}

	void scan()
	{
		scanf("%lf %lf", &x, &y);
	}

	void print() const
	{
		printf("%.10lf %10lf\n", x, y);
	}

	Point operator+(const Point & p) const
	{
		return Point(x + p.x, y + p.y);
	}

	Point operator-(const Point & p) const
	{
		return Point(x - p.x, y - p.y);
	}

	Point operator-() const 
	{
		return Point(-x, -y);
	}

	Point operator*(double k) const
	{
		return Point(x * k, y * k);
	}

	Point operator/(double k) const
	{
		return Point(x / k, y / k);
	}

	double operator%(const Point & p) const
	{
		return x * p.x + y * p.y;
	}

	double operator*(const Point & p)
	{
		return x * p.y - y * p.x;
	}

	double length() const
	{
		return mySqrt(*this % *this);
	}

	double distTo(const Point &p) const
	{
		return (*this - p).length();
	}

	double distTo(const Point & A, const Point & B) const
	{
		double d = A.distTo(B);
		if (doubleEqual(d, 0))
		{
			throw "A=B";
		}
		double s = (*this - A) * (*this - B);
		return fabs(s) / d;
	}

	Point normalize(double k = 1) const
	{
		double len = length();
		if (doubleEqual(len, 0))
		{
			if (doubleEqual(k, 0))
			{
				return Point();
			}
			throw "zero-size vector";
		}
		return *this * (k / len);
	}

	Point getH(const Point & A, const Point & B) const
	{
		Point C = *this;
		Point v = B - A;
		Point u = C - A;
		double k = v % u / v.length();
		v = v.normalize(k);
		Point H = A + v;
		return H;
	}

	Point rotate() const
	{
		return Point(-y, x);
	}

	Point rotate(double alpha) const
	{
		return rotate(cos(alpha), sin(alpha));
	}

	Point rotate(double cosa, double sina) const
	{
		Point v = *this;
		Point u = v.rotate();
		Point w = v * cosa + u * sina;
		return w;
	}

	bool isZero() const
	{
		return doubleEqual(x, 0) && doubleEqual(y, 0);
	}

	bool isOnLine(const Point & A, const Point & B) const
	{
		return doubleEqual((A - *this) * (B - *this), 0);
	}

	bool isInSegment(const Point & A, const Point & B) const
	{
		return isOnLine(A, B) && doubleLessOrEqual((A - *this) % (B - *this), 0);
	}

	bool isInSegmentStrictly(const Point & A, const Point & B) const
	{
		return isOnLine(A, B) && doubleLess((A - *this) % (B - *this), 0);
	}

	double getAngle() const
	{
		return atan2(y, x);
	}

	double getAngle(Point u) const
	{
		Point v = *this;
		return atan2(v * u, v % u);
	}
};

int getIntersection(const Point & A, const Point & B, const Point & C, const Point & D, Point & O)
{
	Point v = B - A;
	double s1 = (C - A) * (D - A);
	double s2 = (D - B) * (C - B);
	double s = s1 + s2;
	if (doubleEqual(s, 0))
	{
		if (!A.isOnLine(C, D))
			return 0;
		return 2;
	}
	v = v / s;
	v = v * s1;
	O = A + v;
	return 1;
}

/*int getIntersection(const Point & A, double rA, const Point & B, double rB, Point & M, Point & N)
{
	double d = A.distTo(B);
	if (doubleLess(rA + rB, d) || doubleLess(d, fabs(rA - rB)))
		return 0;
	//double a = (sqr(rA) - sqr(rB) + sqr(d)) / 2 / d;
	double h = mySqrt(sqr(rA) - sqr(a));
	Point v = B - A;
	Point u = v.rotate();
	v = v.normalize(a);
	u = u.normalize(h);
	Point H = A + v;
	M = H + u;
	N - H - u;
	if (u.isZero())
		return 1;
	return 2;
}*/

double getS(Point p1, Point p2, Point p3)
{
	return fabs(((p2 - p1) * (p3 - p1)) / 2);
}

const ld eps = 1e-5;

struct plane
{
	ld a, b, c;
	plane()
	{
		a = b = c = 0;
	}
	plane(ld _a, ld _b, ld _c)
	{
		a = _a, b = _b, c = _c;
	}

	bool good(pair < ld, ld > &p)
	{
		ld res = a * p.fst + b * p.snd + c ;
		return a * p.fst + b * p.snd + c > -eps;
	}

	pair < ld, ld > getCenter()
	{
		return mp(-a * c, -b * c); 
	}
};

bool intersect(const plane &a, const plane &b, pair < ld, ld > &res)
{
	ld det = (a.a * b.b - a.b * b.a);

	if (abs(det) < eps)
		return false;

	ld x = (a.c * b.b - a.b * b.c) / (-det);
	ld y = (a.a * b.c  - a.c * b.a) / (-det);

	res = mp(x, y);
	return true;
}

inline ld sqr(ld x)
{
	return x * x;
}

bool check(vector < plane > &a)
{
	random_shuffle(a.begin(), a.end());

	pair < ld, ld > gp = a[0].getCenter();;

	for (int i = 1; i < a.size(); i++)
	{
		if (a[i].good(gp))
			continue;

		pair < ld, ld > cp = a[i].getCenter();
		assert(a[i].good(cp));

		pair < ld, ld > lp = mp(cp.fst + a[i].b * (-1e12), cp.snd - a[i].a * (-1e12));
		pair < ld, ld > rp = mp(cp.fst + a[i].b * 1e12, cp.snd - a[i].a * 1e12);

		assert(a[i].good(lp));
		assert(a[i].good(rp));

		ld l = -1e12;
		ld r = 1e12;

		for (int j = 0; j < i; j++)
		{
			pair < ld, ld > p;

			if (!intersect(a[j], a[i], p))
				continue;

			if (a[j].good(lp))
			{
				ld curr = sqrt(sqr(p.fst - cp.fst) + sqr(p.snd - cp.snd));

				if ((sqr(p.fst - lp.fst) + sqr(p.snd - lp.snd)) < (sqr(p.fst - rp.fst) + sqr(p.snd - rp.snd)))
					curr = -curr;
				r = min(r, curr);
			}
			else
			{
				ld curr = sqrt(sqr(p.fst - cp.fst) + sqr(p.snd - cp.snd));

				if ((sqr(p.fst - lp.fst) + sqr(p.snd - lp.snd)) < (sqr(p.fst - rp.fst) + sqr(p.snd - rp.snd)))
					curr = -curr;
				l = max(l, curr);
			}
		}

		pair < ld, ld > p1 = mp(cp.fst + a[i].b * (l + r) / 2, cp.snd - a[i].a * (l + r) / 2), p2;

		for (int j = 0; j <= i; j++)
		{
			if (!a[j].good(p1))
				return false;
		}

		 p1 = mp(cp.fst + a[i].b * (l), cp.snd - a[i].a * (l));
		  p2 = mp(cp.fst + a[i].b * (r), cp.snd - a[i].a * (r));

		  if (abs(l) < abs(r))
			 gp = p1;
		  else
			  gp = p2;
	}

	/*for (int j = 0; j < a.size(); j++)
		{
			if (!a[j].good(gp))
				return false;
		}*/

	return true;
}

const int maxn = 50003;
int x[maxn], y[maxn];
int n;
vector < plane > v;
bool fcheck(int z)
{
	v.clear();
	for (int i = 0; i < n; i++)
	{
		int nxt = i + z + 1;
		if (nxt >= n)
			nxt -= n;
		ld a = y[nxt] - y[i];
		ld b = x[i] - x[nxt];
		ld c = -a * x[i] - b * y[i];
		ld norm = sqrt(sqr(a) + sqr(b));
		a /= norm;
		b /= norm;
		c /= norm;
		v.pb(plane(a, b, c));
	}
	bool res = check(v);
	return !res;
}

int main()
{

	//freopen("a.in", "r", stdin);

	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> x[i] >> y[i];
	}
	int l = 1, r = n - 2;
	fcheck(1);
	/*while (l < r)
	{
		int c = (l + r) / 2;
		if (fcheck(c))
			r = c;
		else
			l = c + 1;
	}*/
	l = 0, r = n - 2;
	while (r - l > 1)
	{
		int mid = (l + r) >> 1;
		if (fcheck(mid))
			r = mid;
		else
			l = mid;
	}
	cout << r << "\n";
	return 0;
}