#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e3+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);


struct Point {
	public :
	double x, y;
	Point(){}
	Point (double _x, double _y){
		x = _x;
		y = _y;
	}
	double distTo(Point o){
		return sqrt(sqr(o.x - x) + sqr(o.y-y));
	}

	Point operator +(Point o){
		return Point(o.x + x, o.y + y);			
	}

	Point operator /(double d){
		return Point(x/d, y/d);
	}

	Point operator -(Point o){
		return Point(x-o.x, y-o.y);		
	}

	double operator *(Point o){
		return x*o.y - y*o.x;
	}

	void print(){
		printf("%.4f %.4f\n", x, y);
	}

	double distance(double A, double B, double C, Point o){
		return abs(A*o.x + B*o.y + C)/sqrt(A*A + B*B);
	}

	pair < double, double > getIntersection(Point a, Point b){
		double A = b.y - a.y;
		double B = -(b.x - a.x);
		double C = -(A*a.x + B*a.y);
		double l = 0, r = distTo(Point(0, 0));
		double len = distTo(Point(0,0));
		for (int iter=0;iter<100;iter++){
			double m1 = l + (r-l)/3;
			double m2 = r - (r-l)/3;
			Point p1 = Point(x/len*m1, y/len*m1);
			Point p2 = Point(x/len*m2, y/len*m2);
			if ( distance(A, B, C, p1) < distance(A, B, C, p2) ){
				r = m2;
		   	}
		   	else
		   		l = m1;
		}	
		return mp(x/len*l, y/len*l);
	}

};

vector < Point > v;
double total;
Point F;

bool onSegment(vector < Point > v, Point F){
	int ind1 = 0, ind2 = 0;
	double dist = -1.0;
	for (int i=0;i<3;i++){
		for (int j=i+1;j<3;j++){
			double distance = F.distTo(v[i]) + F.distTo(v[j]);
			if ( distance <= v[i].distTo(v[j]) ) return true;
		}
	}
	return false;
}
/*

bool onSegment(vector < Point > v, Point F){
	int ind1 = 0, ind2 = 0;
	double dist = -1.0;
	for (int i=0;i<3;i++){
		for (int j=i+1;j<3;j++){
			double distance = F.distTo(v[i]) + F.distTo(v[j]);

			if ( v[i].distTo(v[j]) > dist){
				dist = v[i].distTo(v[j]);
				ind1 = i;
				ind2 = j;				
			}
			//if ( abs(distance - v[i].distTo(v[j])) < eps  ) return true;
		}
	}
	Point mid = (v[ind1] + v[ind2])/2.0;
	int ind3 = 3 - ind1 - ind2;
	return F.distTo(v[ind3]) + F.distTo(mid) <= v[ind3].distTo(mid);
	//return false;
}

*/

double Area(Point a, Point b, Point c){
	Point ab = b-a;
	Point ac = c-a;
	return abs(ab*ac);
}

bool inside(Point a, Point b, Point c, Point F){
	double s1 = Area(a, b, F);
	double s2 = Area(a, c, F);
	double s3 = Area(b, c, F);
	return s1 + s2 + s3 == Area(a, b, c);
}

bool cross(Point a, Point b){
	return (F*a) * (F*b) <= 0 && ((b-a)*(F-a)) * ((b-a)*(Point(0,0)-a)) <= 0;	
}

bool intersects(Point a, Point b, Point c){
	set < pair < double, double > > S;
	int cnt = 0;
	if ( cross(a, b) ){
		cnt++;
		S.insert(F.getIntersection(a, b));
	}
	if ( cross(b, c) ){
		cnt+=10;
		S.insert(F.getIntersection(b, c));
	}
	if ( cross(a, c) ){
		cnt+=100;
		S.insert(F.getIntersection(a, c));
	}

	/*
	if ( sz(S) == 1 ){
		cout <<"cnt is "<<cnt<<endl;
		a.print();
		b.print();
		c.print();
		pair < double, double > temp = *S.begin();
		cout <<temp.f<<" "<<temp.s<<endl;
		cout <<"---"<<endl;
	}
	cout <<sz(S)<<endl;
	*/
	return sz(S) == 2;
}

void get(vector < Point > &v, Point F){
	vector < Point > res;		 	
	int ind1 = 0, ind2 = 0;
	double dist = -1.0;
	for (int i=0;i<3;i++){
		for (int j=i+1;j<3;j++){
			if ( v[i].distTo(v[j]) > dist ){
				dist = v[i].distTo(v[j]);
				ind1 = i; ind2 = j;
			}
		}
	}

	Point mid = (v[ind1] + v[ind2])/2;
	int ind3 = 3-ind1-ind2;
	res.pb(mid);
	res.pb(v[ind3]);
	if ( inside(v[ind1], v[ind3], mid, F) ){
		res.pb(v[ind1]);
		if ( intersects(v[ind2], mid, v[ind3]) )
			total += Area(v[ind2], mid, v[ind3])/2.0;
	}
	else {
		res.pb(v[ind2]);
		if ( intersects(v[ind1], mid, v[ind3]) )
			total += Area(v[ind1], mid, v[ind3])/2.0;
	}
	v.clear();
	v = res;
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	cin >>F.x>>F.y;

	v.pb(Point(0,0));
	v.pb(Point(10,10));
	v.pb(Point(10, 0));

	for (int iter=0;iter<10000;iter++){
		get(v, F);	    
		if ( onSegment(v, F)){
			//v[0].print();
			//v[1].print();
			//v[2].print();
			total += Area(v[0], v[1], v[2])/2.0;
			break;
		}
	}

	printf("%.9f", total);


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}


