#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)2e4+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n;
int ans[maxn];
int cc = 1;

void answer(vector < pair < pii, int > > &v){
	forit(it, v){
		int ind = (*it).s;
		ans[ind] = cc;
	}	
}

bool cw(pii a, pii b, pii c){
	pii ab = mp(b.f - a.f, b.s - a.s);
	pii ac = mp(c.f - a.f, c.s - a.s);
	return ab.f * ac.s - ab.s * ac.f > 0;
}

bool ccw(pii a, pii b, pii c){
	pii ab = mp(b.f - a.f, b.s - a.s);
	pii ac = mp(c.f - a.f, c.s - a.s);
	return ab.f * ac.s - ab.s * ac.f < 0;
}

void show(vector < pair < pii, int > > v){
	forit(it, v){
		cout <<(*it).f.f<<" "<<(*it).f.s<<" "<<(*it).s<<endl;
	}
}

void convex_hull(vector < pair < pii, int > > &v){
	if ( sz(v) < 3 ){
		answer(v);
		v.clear();
		return;
	}

	pii p1 = v[0].f;
	pii p2 = v.back().f;
	
	vector < pair < pii, int > > up;
	vector < pair < pii, int > > down;

	up.pb(v[0]);
	down.pb(v[0]);

	vector < pair < pii, int > > res1;
	vector < pair < pii, int > > res2;

	for (int i=1;i<sz(v);i++){
		if ( i == sz(v) - 1 || !cw(p1, p2, v[i].f) ){
			int cur = sz(res1);
			while ( sz(up) >= 2 && !cw(up[sz(up)-2].f, up[sz(up)-1].f, v[i].f) ){
				res1.pb(up.back());
				up.pop_back();				
			}	
			if ( cur != sz(res1) )
				reverse(res1.begin() + cur, res1.end());
			up.pb(v[i]);
		}
		if ( i == sz(v) - 1 || !ccw(p1, p2, v[i].f) ){
			int cur = sz(res2);
			while( sz(up) >= 2 && !ccw(down[sz(down)-2].f, down[sz(down)-1].f, v[i].f) ){
				res2.pb(down.back());
				down.pop_back();
			}
			if ( cur != sz(res2) )
				reverse(res2.begin() + cur, res2.end());
			down.pb(v[i]);
		}
	}
	answer(up);
	answer(down);
	v.clear();
	merge(all(res1), all(res2), back_inserter(v));
	v.resize(unique(all(v)) - v.begin());
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	scanf("%d", &n);

	vector < pair < pii, int > > v(n);

	for (int i=0;i<n;i++){
		scanf("%d%d", &v[i].f.f, &v[i].f.s);
		v[i].s = i;
	}

	sort(all(v));

	while ( true ){
		convex_hull(v);
		cc++;
		if ( sz(v) == 0 ) break;
	}

	for (int i=0;i<n;i++){
		printf("%d\n", ans[i]);
	}

	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
