#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

ld eps = 1e-9;

struct Point {
	ld x, y, z;

	Point() {
	}

	Point(ld x, ld y, ld z):x(x), y(y), z(z) {
	}

	Point operator - (const Point& p)const {
		return Point(x - p.x, y - p.y, z - p.z);
	}

	Point operator + (const Point& p)const {
		return Point(x + p.x, y + p.y, z + p.z);
	}

	bool operator < (const Point& p) const{
		return x < p.x || x == p.x && mp(y, z) < mp(p.y, p.z);
	}

	Point operator * (const Point& p) const{
		return Point(y * p.z - z * p.y, z * p.x - x * p.z, x * p.y - y * p.x);
	}

	int operator % (const Point& p) const {
		return x * p.x + y * p.y + z * p.z;
	}

	ld sqrDist() const {
		return x * x + y * y + z * z;
	}

	void scan() {
		cin >> x >> y >> z;
	}

	Point operator * (ld c) const {
		return Point(x * c, y * c, z * c);
	}

};

struct Point2D {
	ld x, y;

	Point2D() {
	}

	Point2D(ld x, ld y):x(x), y(y) {
	}

	Point2D operator - (const Point2D& p)const {
		return Point2D(x - p.x, y - p.y);
	}

	bool operator < (const Point2D& p) const{
		return x < p.x || x == p.x && y < p.y;
	}

	bool operator == (const Point2D& p) const {
		return fabs(x - p.x) < eps && fabs(y - p.y) < eps;
	}

	ld operator *(const Point2D& p) const{
		return x * p.y - y * p.x;
	}
};

int n, zmin, zmax;

Point points[101];

void solve() {
	cin >> n >> zmin >> zmax;
	for (int i = 0; i < n; ++i)
		points[i].scan();

	for (int z = zmin; z <= zmax; ++z) {

		vector<Point2D> need;

		for (int i = 0; i < n; ++i) {
			if (fabs(points[i].z - z) < eps) {
				need.push_back(Point2D(points[i].x, points[i].y));
				continue;
			}
			for (int j = 0; j < n; ++j)
				if (i != j && points[i].z < z && points[j].z + eps > z) {

					ld coef = (z - points[i].z) / (points[j].z - points[i].z);

					Point toAdd = points[i] + (points[j] - points[i]) * coef;

					need.push_back(Point2D(toAdd.x, toAdd.y));
				}
		}

		sort(all(need));

		need.erase(unique(all(need)), need.end());

		vector<Point2D> top, bottom;
		//cout << need.size() << "\n";
		for(int i = 0; i < need.size(); ++i) {
			while(top.size() >= 2 && (need[i] - top.back()) * (top.back() - top[top.size() - 2]) > 0) {
				top.pop_back();
			}
			top.push_back(need[i]);
#define top bottom
			while(top.size() >= 2 && (need[i] - top.back()) * (top.back() - top[top.size() - 2]) < 0) {
				top.pop_back();
			}
			top.push_back(need[i]);
#undef top
		}


		for (int i = bottom.size() - 1; i > 0; --i)
			top.push_back(bottom[i]);

		ld ans = 0;
		for (int i = 0; i < top.size(); ++i)
			ans += top[i] * top[(i + 1) % top.size()];

		ans = fabs(ans) / 2.0;

		cout << ans << "\n";

	}


}