#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

const ld PI = acos((ld)-1.0);

const ld eps = 1e-9;

struct Point {
	ld x, y, z;

	Point() {
	}

	Point(ld x, ld y, ld z):x(x), y(y), z(z) {
	}

	ld& operator [] (int c) {
		switch(c) {
		case 0 : 
			return x;
			break;
		case 1:
			return y;
			break;
		case 2:
			return z;
			break;
		default:
			assert(false);
		}
	}

	ld distTo(const Point& p) const {
		return (*this - p).dist();
	}

	Point operator - (const Point& p)const {
		return Point(x - p.x, y - p.y, z - p.z);
	}

	Point operator + (const Point& p)const {
		return Point(x + p.x, y + p.y, z + p.z);
	}

	bool operator < (const Point& p) const{
		return x < p.x || x == p.x && mp(y, z) < mp(p.y, p.z);
	}

	Point operator * (const Point& p) const{
		return Point(y * p.z - z * p.y, z * p.x - x * p.z, x * p.y - y * p.x);
	}

	ld operator % (const Point& p) const {
		return x * p.x + y * p.y + z * p.z;
	}

	ld sqrDist() const {
		return x * x + y * y + z * z;
	}

	void scan() {
		cin >> x >> y >> z;
	}

	Point operator * (ld c) const {
		return Point(x * c, y * c, z * c);
	}

	ld dist() const {
		return sqrt(x * x + y * y + z * z);
	}

};


int n;
vector<Point> points;

ld distSphere(Point a, Point b) {
	return 2 * asin((a - b).dist() / 2);
}

int findCommonPoint(Point n1, ld d1, Point n2, ld d2, Point& ans) {

	for (int i = 2; i >= 0; --i) {
		vector<ld> N1, N2;
		for (int j = 0; j < 3; ++j)
			if (j != i) {
				N1.push_back(n1[j]);
				N2.push_back(n2[j]);
			}
		ld det = (N1[0] * N2[1] - N2[0] * N1[1]);
		if (fabs(det) < eps) {
			continue;
		}

		ld detX = -d1 * N2[1] + d2 * N1[1];
		ld detY = -N1[0] * d2 + N2[0] * d1;

		int cnt = 0;
		for (int j = 0; j < 3; ++j) {
			if (j == i)
				ans[j] = 0;
			else {
				if (cnt == 0)
					ans[j] = detX / det;
				else
					ans[j] = detY / det;
				++cnt;
			}
		}

		return 1;
	}

	return 0;

}

bool checkExcept(Point candy, int I, int J, ld alpha) {
	for (int i = 0; i < n; ++i)
		if (i != I && i != J) {
			ld curDist = distSphere(candy, points[i]);
			if (curDist < alpha)
				return true;
		}
	return false;
}

ld getReal(ld alpha) {
	return sqrt(1 + 1 - 2 * cos(alpha));
}

bool check(ld alpha) {
	bool hasIntersection = false;
	for (int i = 0; i < n; ++i)
		for (int j = i + 1; j < n; ++j) {
			if (distSphere(points[i], points[j]) <= 2 * alpha) {

				ld realRadius = getReal(alpha);

				hasIntersection = true;

				Point normal = points[i] * points[j];
				
				Point repr;
				if (!findCommonPoint(points[i] * 2, realRadius * realRadius - points[i].sqrDist() - 1, points[j] * 2, realRadius * realRadius - points[j].sqrDist() - 1, repr)) {
					return false;
				}

				//assert(fabs(repr.distTo(points[i]) - alpha) < eps);

				//assert(fabs((repr % points[j]) * 2 + alpha * alpha - points[j].sqrDist()) < eps);

				ld A = normal.sqrDist(), B = 2 * (repr % normal), C = repr.sqrDist() - 1;

				ld D = B * B - 4 * A * C;
				if (D < -eps) {
					return false;
				}
				D = sqrt(fabs(D));

				for (int dom = -1; dom <= 1; dom += 2) {
					ld x = (-B + dom * D) / 2 / A;
					if (!checkExcept(repr + (normal * x), i, j, alpha))
						return true;
				}

			}
		}

	return !hasIntersection;
}

void solve() {
	cin >> n;
	if (n == 1) {
		cout << PI << "\n";
		return;
	}

	for (int i = 0; i < n; ++i) {
		ld phi, psi;
		cin >> psi >> phi;
		psi = psi / 180 * PI;
		phi = phi / 180 * PI;
		Point cur( cos(psi) * cos(phi), cos(psi) * sin(phi), sin(psi) );
		points.push_back(cur);
	}

	ld l = 0, r = PI;

	for (int w = 0; w < 100; ++w) {
		ld m = (l + r) / 2;
		if (check(m))
			l = m;
		else
			r = m;
	}

	cout << r << "\n";

}