#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define double long double

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

struct Point
{
	double x, y;
	Point(){}
	Point(double _x, double _y) : x(_x), y(_y) {}
	Point (Point p1, Point p2)
	{
		x = p2.x - p1.x;
		y = p2.y - p1.y;
	}
	double operator % (Point an)
	{
		return x * an.y - y * an.x;
	}
};

const double eps = 1.0e-6;

double answer = 0.0;
Point P;

inline int sgn(double x)
{
	if (abs(x) < eps)
		return 0;
	return (x > eps ? 1 : -1);
}

inline bool intersect2d(double s1, double f1, double s2, double f2)
{
	if (s1 - f1 > 0.0)
		swap(s1, f1);
	if (s2 - f2 > 0.0)
		swap(s2, f2);
	double maxx = max(s1, s2);
	double minn = min(f1, f2);
	return minn - maxx >= -eps;
}

struct Seg
{
	Point p1, p2;
	Seg(Point _p1, Point _p2) : p1(_p1), p2(_p2) {}
	inline bool intersect(Seg an)
	{
		Point p3 = an.p1;
		Point p4 = an.p2;
		if (!intersect2d(p1.x, p2.x, p3.x, p4.x))
			return false;
		if (!intersect2d(p1.y, p2.y, p3.y, p4.y))
			return false;
		Point p1p2(p1, p2);
		Point p1p3(p1, p3);
		Point p1p4(p1, p4);
		double pr1 = p1p2 % p1p3;
		double pr2 = p1p2 % p1p4;
		if (sgn(pr1) * sgn(pr2) > 0)
			return false;
		Point p3p4(p3, p4);
		Point p3p1(p3, p1);
		Point p3p2(p3, p2);
		double pr3 = p3p4 % p3p1;
		double pr4 = p3p4 % p3p2;
		if (sgn(pr3) * sgn(pr4) > 0)
			return false;
		return true;
	}
};

//const double eps2 = 1.0e-9;

void go(Point p1, Point p2, Point p3, double cur)
{
	//if (cur < eps)
	//	return;
	Point mid((p2.x + p3.x) / 2.0, (p2.y + p3.y) / 2.0);
	Point vect1(p1, mid);
	Point vect2(p1, P);
	double pr1 = vect1 % vect2;
	Seg seg1(P, Point(0.0, 0.0));
	Seg seg2(p1, mid);
	if (seg1.intersect(seg2))
		answer += cur; 
	if (sgn(pr1) == 0)
		return;
	//if (abs(pr) < eps)
	//	return;
	
	
	if (sgn(pr1) == -1)
	{
		//answer += cur;
		go(mid, p3, p1, cur / 2.0);
		//go(mid, p1, p3, cur / 2.0);
		
	}
	else
	{
		
		go(mid, p1, p2, cur / 2.0);
		//go(mid, p2, p1, cur / 2.0);
		
	}
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	scanf("%Lf%Lf", &P.x, &P.y);
	go(Point(10.0, 0.0), Point(0.0, 0.0), Point(10.0, 10.0), 25.0);	
	printf("%.15Lf", answer);
}