#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define pb push_back
#define vi vector <int>

struct Point
{
	int x, y, number;
	int sqrlength()
	{
		return x * x + y * y;
	}
	int operator % (Point an)
	{
		return x * an.y - y * an.x;
	}
	double distTo(Point an)
	{
		return sqrt((double)(x - an.x) * (x - an.x) + (y - an.y) * (y - an.y));
	}
	Point(){}
	Point(Point p1, Point p2) : x(p2.x - p1.x), y(p2.y - p1.y) {}
};

bool cmp_x(Point first, Point second)
{
	if (first.x == second.x)
		return first.y < second.y;
	return first.x < second.x;
}

const int maxn = 2e4 + 5;

int st[maxn];
int sz, it_number;
Point p[maxn];
int answer[maxn];
//Point list[maxn];

const double eps = 1.0e-6;

void get(vector <int> & numbers)
{
	if (numbers.size() <= 2)
	{
		forn(j, numbers.size())
			answer[numbers[j]] = it_number;
		return;
	}
	vector <Point> list;
	list.resize(numbers.size());
	forn(j, numbers.size())
		list[j] = p[numbers[j]];
	/*if (flag)
	{
		int start = 1;
		fore(pos, 2, list.size() - 2)
		{
			if (list[pos].x != list[start].x)
			{
				reverse(list.begin() + start, list.begin() + pos);
				start = pos;
			}
		}
		reverse(list.begin() + start, list.end());
	}*/
	st[0] = 0;
	st[1] = 1;
	sz = 2;
	fore(i, 2, list.size() - 1)
	{
		while(sz > 1)
		{
			Point prev(list[st[sz - 2]], list[st[sz - 1]]);
			Point nnew(list[st[sz - 1]], list[i]);
			double pr = prev % nnew;
			if ((pr > 0) || ((pr == 0) && prev.sqrlength() < nnew.sqrlength()))
			{
				sz--;
			}
			else break;
		}
		st[sz] = i;
		sz++;
	}
	forn(j, sz)
		answer[numbers[st[j]]] = it_number;
	int cur = 0;
	st[sz] = st[0];
	forn(j, numbers.size()) if (answer[numbers[j]] == 0)
	{
		double d1 = list[st[cur]].distTo(list[j]);
		double d2 = list[st[cur + 1]].distTo(list[j]);
		double d3 = list[st[cur]].distTo(list[st[cur + 1]]);
		if (abs(d1 + d2 - d3) < eps)
			answer[numbers[j]] = it_number; 
	}
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n;
	scanf("%d", &n);
	forn(j, n)
	{
		scanf("%d%d", &p[j].x, &p[j].y);
		p[j].number = j;
	}
	sort(p, p + n, cmp_x);
	
	while(true)
	{
		it_number++;
		vi cur;
		cur.clear();
		forn(j, n) if (answer[j] == 0)
			cur.pb(j);
		if (cur.empty())
			break;
		int chosen_left = cur[0];
		int chosen_right = cur.back();
		/*int chosen_left = cur[0];
		int chosen_right = cur[0];
		fore(e, 1, cur.size() - 1)
		{
			int j = cur[e];
			if (p[j].x < p[chosen_left].x)
				chosen_left = j;
			if (p[j].x > p[chosen_right].x)
				chosen_right = j;
		}*/
		Point v(p[chosen_left], p[chosen_right]);
		vi lower, upper;
		//lower.pb(chosen_left);
		//upper.pb(chosen_left);
		forn(e, cur.size())
		{
			int j = cur[e];
			Point v1(p[chosen_left], p[j]);
			double pr = v % v1;
			if (pr == 0)
			{
				if (j == chosen_left || j == chosen_right)
				{
					upper.pb(j);
					lower.pb(j);
				}
				else continue;
			}
			else
			{
				if (pr > 0)
					upper.pb(j);
				else lower.pb(j);
			}
		}
		//lower.pb(chosen_right);
		//upper.pb(chosen_right);
		get(upper);
		reverse(lower.begin(), lower.end());
		get(lower);
	}
	vi result(n);
	forn(j, n)
		result[p[j].number] = answer[j];
	forn(j, n)
		printf("%d\n", result[j]);
}