#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair< int, int > pii;
typedef vector< int > vi;

typedef int ld;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

struct Point {
	ld x, y; 
	Point(ld _x = 0, ld _y = 0) : x(_x), y(_y) {}
}; 

typedef Point Vec;


bool operator < (const Point& a, const Point& b)
{
	return a.x == b.x ? a.y < b.y : a.x < b.x;
}

Point operator- (const Point& a, const Point& b)
{
	return Point(a.x - b.x, a.y - b.y);
}

ld vecm(const Vec &a, const Vec &b) {
	return a.x * b.y - a.y * b.x; 
}

ll sqrLength(const Point& a)
{
	return sqr(a.x) + sqr(a.y);
}

const int maxn = 20000 + 100;

Point p[maxn];
Point pp[maxn];
int answer[maxn];

int ans[maxn];

bool used[maxn];

bool cmp(const Point& a, const Point& b)
{
	ll v = vecm(a, b);
	return (v == 0 ? sqrLength(a) < sqrLength(b) : v > 0);
}

int tmp[maxn];
int tmpSize;

map < Point, int > mapa;
int COUNTER = 0;

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);

	//ios::sync_with_stdio(false); 

	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d%d", &pp[i].x, &pp[i].y);
		if (mapa[pp[i]] == 0)
			mapa[pp[i]] = ++COUNTER;
	}

	int nn = n;

	n = COUNTER;
	for (map < Point, int >::iterator it = mapa.begin(); it != mapa.end(); ++it)
	{
		p[it->second - 1] = it->first;
	}

	int Z = 0;

	while (1)
	{
		int startJ = -1;
		for (int i = 0; i < n; ++i)
		{
			if (used[i])
				continue;
			if (startJ == -1 || p[i] < p[startJ])
				startJ = i;
		}
		if (startJ == -1)
			break;

		++Z;
		answer[startJ] = Z;
		int prevJ = startJ;

		tmpSize = 0;
		tmp[tmpSize++] = startJ;

		while (1)
		{
			int bestJ = -1;
			for (int i = 0; i < n; ++i)
			{
				if (i == prevJ || used[i])
					continue;
				if (bestJ == -1 || cmp(p[i] - p[prevJ], p[bestJ] - p[prevJ]))
					bestJ = i;
			}
			if (bestJ == -1 || bestJ == startJ)
				break;
			tmp[tmpSize++] = bestJ;
			answer[bestJ] = Z;
			prevJ = bestJ;
		}

		for (int i = 0; i < tmpSize; ++i)
			used[tmp[i]] = true;

	}

	for (int i = 0; i < nn; ++i)
	{
		int cc = mapa[pp[i]];
		printf("%d\n", answer[cc - 1]);
	}

	return 0;
}