#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-3;
const double pi = 4 * atan(double(1));

struct vt
{
	double x, y, z;
	vt(double _x, double _y, double _z)
	{
		x = _x, y = _y, z = _z;
	}
	friend vt operator +(vt a, vt b)
	{
		return vt(a.x + b.x, a.y + b.y, a.z + b.z);
	}
	friend vt operator -(vt a, vt b)
	{
		return vt(a.x - b.x, a.y - b.y, a.z - b.z);
	}
	friend double operator *(vt a, vt b)
	{
		return a.x * b.x + a.y * b.y + a.z * b.z;
	}
	friend vt operator ^(vt a, vt b)
	{
		return vt(a.y * b.z - b.y * a.z, a.z * b.x - b.z * a.x, a.x * b.y - b.x * a.y);
	}
	friend vt operator /(vt v, double k)
	{
		return vt(v.x / k, v.y / k, v.z / k);
	}
	friend vt operator *(vt v, double k)
	{
		return vt(v.x * k, v.y * k, v.z * k);
	}
	friend vt operator -(vt v)
	{
		return vt(-v.x, -v.y, -v.z);
	}
	double abs()
	{
		return sqrt(x * x + y * y + z * z);
	}
	vt norm()
	{
		return (*this) / abs();
	}
	vt(){}
};

const int N = 61;

int sign(double x)
{
	return (x > eps) - (x < -eps);
}

struct cmp
{
	vt o, n;
	vt* P;
	cmp(vt _o, vt _n, vt* _P)
	{
		o = _o, n = _n, P = _P;
	}
	bool operator()(int a, int b)
	{
		vt u = P[a] - o;
		vt v = P[b] - o;
		return (sign((u ^ v) * n) == 1);
	}
};

struct poly
{
	int n;
	vt P[N];
	bool used[N][N][N];
	double ans;
	poly()
	{
		scanf("%d", &n);
		memset(used, 0, sizeof(used));
		for (int i = 0; i < n; i++)
			scanf("%lf %lf %lf", &P[i].x, &P[i].y, &P[i].z);
		vt sumv(0, 0, 0);
		double sum = 0;
		vector<pair<vt, vt> > faces;
		for (int a = 0; a < n; a++)
			for (int b = 0; b < a; b++)
				for (int c = 0; c < b; c++)
				{
					if (used[a][b][c])
						continue;
					vt v = (P[b] - P[a]) ^ (P[c] - P[a]);
					int sgn = 0;
					vector<int> on;
					bool bad = false;
					for (int i = 0; i < n && !bad; i++)
					{
						if (i == a || i == b || i == c)
							on.push_back(i);
						else
						{
							int s = sign(v * (P[i] - P[a]));
							if (s == 0)
								on.push_back(i);
							else if (sgn == 0)
								sgn = s;
							else if (sgn != s)
								bad = true;
						}
					}
					if (sgn < 0)
						sgn = -sgn, v = -v;
					if (bad)
						continue;
					for (int i = 0; i < on.size(); i++)
						for (int j = 0; j < on.size(); j++)
							for (int k = 0; k < on.size(); k++)
							{
								if (i == j || j == k || i == k)
									continue;
								used[on[i]][on[j]][on[k]] = true;
							}
					sort(on.begin() + 1, on.end(), cmp(P[on[0]], v, P));
					eprintf("new face:");
					for (int i = 0; i < on.size(); i++)
						eprintf(" %d", on[i]);
					eprintf("\n");
					faces.push_back(make_pair(P[on[0]], v.norm()));
					for (int i = 1; i + 1 < on.size(); i++)
					{
						vt a = P[on[0]], b = P[on[i]], c = P[on[i + 1]];
						double w = (a ^ b) * c;
						sumv = sumv + (a + b + c) / 4.0 * w;
						sum += w;
					}
				}
		sumv = sumv / sum;
		eprintf("%.3lf %.3lf %.3lf\n", sumv.x, sumv.y, sumv.z);
		double mx = 1e100;
		for (int i = 0; i < faces.size(); i++)
			mx = min(mx, (sumv - faces[i].first) * faces[i].second);
		ans = mx;
	}
};

int main() {
#ifdef LOCAL42
#define TASK "B"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	poly A;
	poly B;
	printf("%.10lf\n", A.ans + B.ans);
	return 0;
}
