#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define double ld

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(1e5) + 100;

struct point {

	double x, y;

	point() {}

	point(double x, double y) {
		this->x = x;
		this->y = y;
	}

};

struct line {

	double a, b, c;
	double ang;

	line() {}

	line(point &A, point &B) {
		a = A.y - B.y;
		b = B.x - A.x;
		c = -a * A.x - b * A.y;
		ang = atan2l(b, a);
	}

};

bool operator < (const line &a, const line &b) {
	if (fabsl(a.ang - b.ang) < eps) {
		return a.c > b.c;
	}
	return a.ang < b.ang;
}

bool operator == (const line &a, const line &b) {
	return fabsl(a.ang - b.ang) < eps;
}

int n;
bool used[N];
point p[N];
pair<line, int> lines[N];
pair<line, int> st[N];

inline double dist(line &l, point &p) {
	return l.a * p.x + l.b * p.y + l.c;
}

inline bool bad(line &a, line &b, line &c) {
	double d = a.a * b.b - b.a * a.b;
	//assert(fabsl(d) > eps);
	point cur((a.b * b.c - b.b * a.c) / d, (a.c * b.a - a.a * b.c) / d);
	//assert(fabs(dist(a, cur)) < eps && fabs(dist(b, cur)) < eps);
	if (dist(c, cur) < eps) {
		return true;
	}
	return false;
}

inline int my_rand() {
	return (rand() << 15) | rand();
}

inline void gen() {
	freopen("D2.in", "w", stdout);
	int n = 1000;
	cout << n << endl;
	vector<double> angs;
	for (int i = 0; i < 1000; ++i) {
		double ang = my_rand() * 1.0 / (RAND_MAX * (RAND_MAX + 1) + RAND_MAX) * 2 * pi;
		angs.pb(ang);
	}
	sort(all(angs));
	for (int i = 0; i < sz(angs); ++i) {
		int x = 1e6 * cos(angs[i]);
		int y = 1e6 * sin(angs[i]);
		cout << x << " " << y << endl;
	}
	exit(0);
}

inline bool can(int mid) {
	for (int i = 0; i < n; ++i) {
		lines[i] = mp(line(p[i], p[(i + mid) % n]), i);
	}
	sort(lines, lines + n);
	int m = unique(lines, lines + n) - lines;
	for (int i = 0; i < n; ++i) {
		used[i] = false;
	}
	int sz = 0;
	for (int i = 0; i < 2 * m; ++i) {
		pair<line, int> cur = lines[i % m];
		if (i >= m) {
			cur.fs.ang += 2 * pi;
		}
		while (sz > 0) {
			if (cur.fs.ang - st[sz - 1].fs.ang > pi - eps) {
				used[st[--sz].sc] = false;
				continue;
			}
			if (sz >= 2 && bad(st[sz - 2].fs, st[sz - 1].fs, cur.fs)) {
				used[st[--sz].sc] = false;
				continue;
			}
			break;
		}
		if (used[cur.sc]) {
			return true;
		}
		used[cur.sc] = true;
		st[sz++] = cur;
	}
	return false;
}

int main() {
	//gen();
#ifdef LOCAL42
#define TASK "D"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%Lf %Lf", &p[i].x, &p[i].y);
	}
	reverse(p, p + n);
	int ans = -1, l = 1, r = n - 1;
	while (l <= r) {
		int mid = (l + r) / 2;
		bool fl = can(mid);
		if (fl) {
			ans = mid;
			l = mid + 1;
		} else {
			r = mid - 1;
		}
	}
	cout << ans << endl;
	return 0;
}
