#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

struct vt
{
	double x, y;
	vt(double _x, double _y)
	{
		x = _x, y = _y;
	}
	friend vt operator +(vt a, vt b)
	{
		return vt(a.x + b.x, a.y + b.y);
	}
	friend vt operator -(vt a, vt b)
	{
		return vt(a.x - b.x, a.y - b.y);
	}
	friend double operator ^(vt a, vt b)
	{
		return a.x * b.y - b.x * a.y;
	}
	friend double operator *(vt a, vt b)
	{
		return a.x * b.x + a.y * b.y;
	}
	friend vt operator *(vt v, double k)
	{
		return vt(v.x * k, v.y * k);
	}
	friend vt operator /(vt v, double k)
	{
		return vt(v.x / k, v.y / k);
	}
	friend bool operator ==(vt a, vt b)
	{
		return fabs(a.x - b.x) + fabs(a.y - b.y) < 1e-9;
	}
	friend bool operator <(vt a, vt b)
	{
		return make_pair(a.x * 2 + a.y * 3, a.x * 4 + a.y * 6) < make_pair(b.x * 2 + b.y * 3, b.x * 4 + b.y * 6);
	}
	vt(){}
};

bool in(vt a, vt b, vt x)
{
	return ((x - a) * (x - b) < eps);
}

bool inter(vt a, vt b, vt c, vt d, vt& x)
{
	assert(fabs((b - a) ^ (d - c)) > eps);
	x = (a * ((b - c) ^ (d - c)) + b * ((d - c) ^ (a - c))) / ((b - a) ^ (d - c));
	return in(a, b, x) && in(c, d, x);
}


struct tri
{
	vt a, b, c;
	tri(vt _a, vt _b, vt _c)
	{
		a = _a, b = _b, c = _c;
	}
};

bool in(vt a, vt b, vt c, vt x)
{
	return (((b - a) ^ (x - a)) >= -eps) && (((c - b) ^ (x - b)) >= -eps) && (((a - c) ^ (x - c)) >= -eps);
}

double go(tri t, vt f)
{
	vt a = t.a, b = t.b, c = t.c;
	eprintf("%.2lf %.2lf | %.2lf %.2lf | %.2lf %.2lf\n", a.x, a.y, b.x, b.y, c.x, c.y);
	assert(((c - b) ^ (a - b)) > eps);
	double s = ((c - b) ^ (a - b)) / 2.0;
	if (s < 1e-6)
		return 0;

	vt v[4] = {a, b, c, a};
	vt w[3];
	int pt = 0;
	for (int i = 0; i < 3; i++)
	{
		vt x = v[i], y = v[i + 1];
		vt q;
		if (inter(x, y, vt(0, 0), f, q))
			w[pt++] = q;
	}
	sort(w, w + pt);
	pt = unique(w, w + pt) - w;
	if (pt == 0)
	{
		eprintf("+ 0\n");
		return 0;
	}
	if (pt == 1)
	{
		if (!in(a, b, c, f) && !in(a, b, c, vt(0, 0)))
		{
			eprintf("+ 0\n");
			return 0;
		}
		tri t1(b, (a + c) / 2, a), t2(c, (a + c) / 2, b);
		return go(t1, f) + go(t2, f);
	}
	else if (pt == 2)
	{
		eprintf("+ %.3lf\n", s);
		return s;
	}
	else
		assert(false);
	return 0;
}

int main() {
#ifdef LOCAL42
#define TASK "G"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	double x, y;
	scanf("%lf %lf", &x, &y);
	
	double ans = go(tri(vt(0, 0), vt(10, 0), vt(10, 10)), vt(x, y));
	printf("%.10lf\n", ans);
	return 0;
}

/*
0.00 0.00 | 10.00 0.00 | 10.00 10.00
10.00 0.00 | 5.00 5.00 | 0.00 0.00
+ 25.000
10.00 10.00 | 5.00 5.00 | 10.00 0.00
5.00 5.00 | 10.00 5.00 | 10.00 10.00
+ 0
10.00 0.00 | 10.00 5.00 | 5.00 5.00
10.00 5.00 | 7.50 2.50 | 10.00 0.00
+ 0
5.00 5.00 | 7.50 2.50 | 10.00 5.00
7.50 2.50 | 7.50 5.00 | 5.00 5.00
+ 3.125
10.00 5.00 | 7.50 5.00 | 7.50 2.50
7.50 5.00 | 8.75 3.75 | 10.00 5.00
8.75 3.75 | 8.75 5.00 | 7.50 5.00
8.75 5.00 | 8.13 4.38 | 8.75 3.75
+ 0
7.50 5.00 | 8.13 4.38 | 8.75 5.00
8.13 4.38 | 8.13 5.00 | 7.50 5.00
+ 0.195
8.75 5.00 | 8.13 5.00 | 8.13 4.38
8.13 5.00 | 8.44 4.69 | 8.75 5.00
+ 0
8.13 4.38 | 8.44 4.69 | 8.13 5.00
8.44 4.69 | 8.13 4.69 | 8.13 4.38
+ 0
8.13 5.00 | 8.13 4.69 | 8.44 4.69
8.13 4.69 | 8.28 4.84 | 8.13 5.00
8.28 4.84 | 8.13 4.84 | 8.13 4.69
8.13 4.84 | 8.20 4.77 | 8.28 4.84
+ 0
8.13 4.69 | 8.20 4.77 | 8.13 4.84
8.20 4.77 | 8.13 4.77 | 8.13 4.69
8.13 4.77 | 8.16 4.73 | 8.20 4.77
+ 0
8.13 4.69 | 8.16 4.73 | 8.13 4.77
8.16 4.73 | 8.13 4.73 | 8.13 4.69
+ 0
8.13 4.77 | 8.13 4.73 | 8.16 4.73
8.13 4.73 | 8.14 4.75 | 8.13 4.77
8.14 4.75 | 8.13 4.75 | 8.13 4.73
+ 0
8.13 4.77 | 8.13 4.75 | 8.14 4.75
8.13 4.75 | 8.13 4.76 | 8.13 4.77
8.13 4.76 | 8.13 4.76 | 8.13 4.75
8.13 4.76 | 8.13 4.75 | 8.13 4.76
+ 0
8.13 4.75 | 8.13 4.75 | 8.13 4.76
8.13 4.75 | 8.13 4.75 | 8.13 4.75
8.13 4.75 | 8.13 4.75 | 8.13 4.75
+ 0
8.13 4.75 | 8.13 4.75 | 8.13 4.75
8.13 4.75 | 8.13 4.75 | 8.13 4.75
+ 0
8.13 4.75 | 8.13 4.75 | 8.13 4.75
8.13 4.75 | 8.13 4.75 | 8.13 4.75
8.13 4.75 | 8.13 4.75 | 8.13 4.75
8.13 4.75 | 8.13 4.75 | 8.13 4.75
8.13 4.75 | 8.13 4.75 | 8.13 4.75
+ 0
8.13 4.76 | 8.13 4.75 | 8.13 4.75
+ 0
8.13 4.77 | 8.13 4.76 | 8.13 4.76
+ 0
8.14 4.75 | 8.13 4.76 | 8.13 4.75
+ 0
8.16 4.73 | 8.14 4.75 | 8.13 4.73
+ 0
8.13 4.84 | 8.13 4.77 | 8.20 4.77
+ 0
8.13 5.00 | 8.13 4.84 | 8.28 4.84
+ 0
8.44 4.69 | 8.28 4.84 | 8.13 4.69
+ 0
10.00 5.00 | 8.75 5.00 | 8.75 3.75
+ 0
7.50 2.50 | 8.75 3.75 | 7.50 5.00
+ 1.563
*/