#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cstdlib>
#include <cstring>
#include <cmath>

using namespace std;

const long double EPS = 1e-9;

struct Point {
    long double x, y;

    Point() {}

    Point(long double x, long double y): x(x), y(y) {}

    Point operator+(const Point &p) const {
        return Point(x + p.x, y + p.y);
    }

    Point operator-(const Point &p) const {
        return Point(x - p.x, y - p.y);
    }

    Point operator/(long double k) const {
        return Point(x / k, y / k);
    }
};

const int MAXN = 50 * 1000 + 5;
Point p[MAXN];

int main(){
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
        cin >> p[i].x >> p[i].y;
    cout << (n == 4? 1 : n - ((2 * n) / 3)) << '\n';
    return 0;
}
