#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cstdlib>
#include <cstring>
#include <cmath>

using namespace std;

struct Point {
    int x, y, id;

    Point() {}

    Point(int x, int y): x(x), y(y) {}

    bool operator<(const Point &p) const {
        return x < p.x || (x == p.x && (y < p.y || (y == p.y && id < p.id)));
    }

    Point operator+(const Point &p) const {
        return Point(x + p.x, y + p.y);
    }

    Point operator-(const Point &p) const {
        return Point(x - p.x, y - p.y);
    }
};

const int MAXN = 20 * 1000 + 5;
int ans[MAXN], n, m;
Point p[MAXN];

int cp(const Point &a, const Point &b) {
    return a.x * b.y - a.y * b.x;
}

void buildCH() {
    if(n <= 2) {
        for(int i = 0; i < n; i++)
            ans[p[i].id] = m;
        n = 0;
        m++;
        return;
    }
    int l = 0;
    for(int i = 1; i < n; i++)
        if(p[i] < p[l])
            l = i;
    swap(p[l], p[n - 1]);
    int h = 1;
    ans[p[n - 1].id] = m;
    while(h < n) {
        l = 0;
        for(int i = 1; i < n - h; i++)
            if(cp(p[i] - p[n - h], p[l] - p[n - h]) > 0)
                l = i;
        if(h > 1 && cp(p[n - 1] - p[n - h], p[l] - p[n - h]) > 0)
            break;
        h++;
        swap(p[l], p[n - h]);
        ans[p[n - h].id] = m;
    }
    m++;
    n -= h;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
        p[i].id = i;
    }
    int k = n;
    while(n)
        buildCH();
    for(int i = 0; i < k; i++)
        cout << ans[i] + 1 << '\n';
    return 0;
}
