#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <hash_set>
#include <hash_map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
using namespace std;

#define EPS 1E-7
#define MOD 10007
#define INF 2000000000

#define mp make_pair

long double FABS(long double a) {
	if (a<EPS) a = -a;
	return a;
}

struct pt{
	long double x,y,z;
	bool operator == (pt a) {
		return (FABS(a.x - x)<EPS && FABS(a.y - y)<EPS && FABS(a.z - z)<EPS);
	}
};

struct pt2{
	long double x,y;
	pt2 operator-(const pt2&a) {
		pt2 res;
		res.x = x-a.x;
		res.y = y-a.y;
		return res;
	}
	long double operator*(const pt2&a) {
		return x*a.y - y*a.x;
	}
	long double operator%(const pt2&a) {
		return x*a.x + y*a.y;
	}
};

vector<pt>points;
pt2 Left;


bool cmp(pt2 a, pt2 b){
	if(fabs((a.x-Left.x)*(b.y-Left.y) - (a.y-Left.y)*(b.x-Left.x)) < 1E-7){
		return (a.x-Left.x)*(a.x-Left.x)+(a.y-Left.y)*(a.y-Left.y) > 
			(b.x-Left.x)*(b.x-Left.x)+(b.y-Left.y)*(b.y-Left.y);
	}
	return ((a.x-Left.x)*(b.y-Left.y) - (a.y-Left.y)*(b.x-Left.x) > 0);
}


double getConvArea(vector<pt2>&vec){
	vector<pt2>vec1,vec2;
	bool ok;
	for(int i=0; i<vec.size(); ++i){
		ok=true;
		for(int j=i+1; j<vec.size(); ++j){
			if(fabs(vec[i].x-vec[j].x)<1E-9 && fabs(vec[i].y-vec[j].y)<1E-9){
				ok=false;
				break;
			}
		}
		if(ok){
			vec1.push_back(vec[i]);
		}
	}

	if(vec1.size()<3){
		return 0;
	}
	stack<pt2>st;
	int Leftmost = -1;
	for(int i=0; i<vec1.size(); ++i){
		if(Leftmost==-1 || (vec1[i].x < vec1[Leftmost].x)){
			Leftmost = i;
		}
	}
	Left = vec1[Leftmost];
	
	vec1.erase(vec1.begin()+Leftmost);

	for(int i=0;i<vec1.size(); ++i){
		int rbound = i;
		for(int j=i+1; j<vec1.size() && fabs((vec1[i]-Left)*(vec1[j]-Left))<EPS; ++j){
			rbound++;
		}
		pt2 toadd = vec1[i];
		for(int j=i+1; j<=rbound; ++j){
			if((toadd-Left)%(toadd-Left) < EPS + (vec1[j]-Left)%(vec1[j]-Left)){
				toadd = vec1[j];
			}
		}
		vec2.push_back(toadd);
		i=rbound;
	}

	sort(vec2.begin(), vec2.end(), cmp);
	st.push(Left);
	st.push(vec2[0]);
	pt2 prev, pprev;
	for(int i=1; i<vec2.size(); ++i){
		prev = st.top();
		st.pop();
		pprev = st.top();
		st.push(prev);
		while(st.size() > 1 && (prev-pprev)*(vec2[i]-prev) < 0){
			st.pop();
			if(st.size() == 1){
				break;
			}
			prev=pprev;
			st.pop();
			pprev = st.top();
			st.push(prev);
		}
		st.push(vec2[i]);
	}
	vector<pt2>conv(st.size());
	for(int i=0; i<conv.size(); ++i){
		conv[i]=st.top();
		st.pop();
	}
	double res=0;
	for(int i=2; i<conv.size(); ++i){
		res += (conv[i]-conv[0])*(conv[i-1]-conv[0])/2;
	}
	return res;
}



int main(){
	//freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);

	int N;
	cin>>N;
	int zmin,zmax;
	cin >> zmin >> zmax;

	vector<pt2>pl;

	points.resize(N);

	for(int i=0; i<N; ++i){
		cin>>points[i].x >>points[i].y >> points[i].z;
	}
	for(int z = zmin; z<=zmax; z++) {
		pl.clear();
		for(int i = 0; i<N; i++) {
			if (FABS(points[i].z-z)<EPS) {
				pt2 a;
				a.x = points[i].x;
				a.y = points[i].y;
				pl.push_back(a);
				continue;
			}
			for(int j = i+1; j<N; j++) {
				if(points[i] == points[j]) continue;
				if (FABS(points[i].z - points[j].z)<EPS) {
					continue;
				}
				else {
					long double t = (z-points[j].z)/(points[i].z-points[j].z);
					if (t>-EPS && t<1+EPS){
						pt2 a;
						a.x = (points[i].x-points[j].x)*t+points[j].x;
						a.y = (points[i].y-points[j].y)*t+points[j].y;
						pl.push_back(a);
					}
					else{
						continue;
					}
				}
			}
		}

		printf("%.6lf\n", getConvArea(pl));

	}

	return 0;
}