#include <iostream>
#include <climits>

typedef long long int Z;

using namespace std;

Z x[5];
Z y[5];

Z m, h, H;

struct P {
	Z x;
	Z y;
	Z z;
};

Z eta(P a, P b, P c, P p) {
	a.x -= c.x;
	a.y -= c.y;
	a.z -= c.z;
	b.x -= c.x;
	b.y -= c.y;
	b.z -= c.z;
	p.x -= c.x;
	p.y -= c.y;
	p.z -= c.z;
	
	P n;
	n.x = a.y * b.z - a.z * b.y;
	n.y = a.z * b.x - a.x * b.z;
	n.z = a.x * b.y - a.y * b.x;
	
	Z dot = n.x * p.x + n.y * p.y + n.z * p.z;
	return dot * dot / (n.x * n.x + n.y * n.y + n.z * n.z);
}

int main() {
	cin >> m >> h >> H;
	for(Z i = 0; i <= 4; ++i) {
		cin >> x[i] >> y[i];
	}
	
	P p{x[0], y[0], h};
	P vert[4];
	vert[0] = P{x[1], y[1], 0};
	vert[1] = P{x[2], y[2], 0};
	vert[2] = P{x[3], y[3], 0};
	vert[3] = P{x[4], y[4], H};
	
	m -= h;
	
	Z d2 = INT_MAX;
	for(Z i = 0; i < 4; ++i) {
	for(Z j = i + 1; j < 4; ++j) {
	for(Z k = j + 1; k < 4; ++k) {
		d2 = min(d2, eta(vert[i], vert[j], vert[k], p));
	}
	}
	}
	
	if(m < 0 || d2 > m * m) {
		cout << "NO\n";
	} else {
		cout << "YES\n";
	}
}
