#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct point {
	double x, y, z;
};

double pointabs(point a) {
	double x = a.x;
	double y = a.y;
	double z = a.z;
	double ans = sqrt(x*x + y*y + z*z);
	return ans;
}

double volume (point a, point b, point c) {
	double ans = a.x * (b.y * c.z - b.z * c.y) - a.y * (b.x * c.z - b.z * c.x) + a.z * (b.x * c.y - b.y * c.x);
	return fabs(ans);
}

double area (point b, point c) {
	point ans;
	ans.x = (b.y * c.z - b.z * c.y);
	ans.y = -(b.x * c.z - b.z * c.x);
	ans.z = (b.x * c.y - b.y * c.z);
	return pointabs(ans);
}

point substr(point a, point b) {
	point ans;
	ans.x = a.x - b.x;
	ans.y = a.y - b.y;
	ans.z = a.z - b.z;
	return ans;
}

bool doubleEqual(double a, double b) {
	return fabs(a-b) < 1e-9;
}

bool LessOrEqual (double a, double b) {
	return a < b || doubleEqual(a, b);
}

int main () {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	double h, H, m;
	cin >> m >> h >> H;
	point pyr[5];
	for (int i = 0; i <= 4; ++i) {
		double x, y;
		cin >> x >> y;
		pyr[i].x = x;
		pyr[i].y = y;
		if (i == 4) 
			pyr[i].z = H;
		else {
			if (i == 0)
				pyr[i].z = h;
			else
				pyr[i].z = 0;
		}
	}
	double L1, L2, L3, L4;
	L1 = volume(substr(pyr[1],pyr[0]), substr(pyr[2],pyr[0]), substr(pyr[3],pyr[0])) / area (substr(pyr[3],pyr[1]), substr(pyr[2], pyr[1]));
	L2 = volume(substr(pyr[1],pyr[0]), substr(pyr[2],pyr[0]), substr(pyr[4],pyr[0])) / area (substr(pyr[4],pyr[1]), substr(pyr[4], pyr[2]));
	L3 = volume(substr(pyr[1],pyr[0]), substr(pyr[3],pyr[0]), substr(pyr[4],pyr[0])) / area (substr(pyr[4],pyr[3]), substr(pyr[4], pyr[1]));
	L4 = volume(substr(pyr[2],pyr[0]), substr(pyr[3],pyr[0]), substr(pyr[4],pyr[0])) / area (substr(pyr[4],pyr[3]), substr(pyr[4], pyr[2]));
	if (LessOrEqual(L2, L1)) swap(L1, L2);
	if (LessOrEqual(L3, L1)) swap(L1, L3);
	if (LessOrEqual(L4, L1)) swap(L1, L4);
	double r = L1 + h;
	if (LessOrEqual(r, m))
		cout << "YES";
	else
		cout << "NO";
	return 0;
}