#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstdio>
#include <cstring>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back 
#define less lessss

using namespace std;

const int N = 1e5;
const int INF = 1e9;
const double eps9 = 1e-9;

bool equal(double a, double b) {
	return abs(a - b) < eps9;
}

bool less(double a, double b) {
	return a < b && !equal(a, b);
}

bool lessOrEq(double a, double b) {
	return a < b || equal(a, b);
}


struct pnt {
	double x, y;
	int id;
	int id2;
	pnt() { }
	pnt(double x, double y): x(x), y(y) { }
	pnt operator - (pnt A) {
		return pnt(x - A.x, y - A.y);
	}
	double operator * (pnt A) {
		return x * A.y - y * A.x;
	}
	double len() {
		return sqrt(x * x + y * y);
	}
	void read() {
		scanf("%lf%lf", &x, &y);
	}
};

pnt stack[N];
pnt O;
pnt p[N];
int answer[N];
pnt b[N];
pnt c[N];
int flag[N];
pnt stack1[N];
pnt stack2[N];


bool cmp(pnt a, pnt b) {
	return less(0, (a - O) * (b - O)) || (equal((a - O) * (b - O), 0) && (a - O).len() < (b - O).len());	
}

vector < pnt > convexHull(vector < pnt > & b) {
	if ((int)b.size() <= 1)
		return b;
	int n = b.size();
	for (int i = 0; i < n; i++)
		if (b[i].y < b[0].y || (b[i].y == b[0].y && b[i].x < b[0].x))
			swap(b[i], b[0]); 
	O = b[0];
	sort(b.begin(), b.end(), cmp);
	int cur = 0;
	for (int i = 0; i < n; i++) {
		for (; cur >= 2 && lessOrEq((stack[cur - 1] - stack[cur - 2]) * (b[i] - stack[cur - 1]), 0); cur--);	
		stack[cur++] = b[i];
	}
	vector < pnt > t;
	for (int i = 0; i < cur; i++)
		t.pb(stack[i]);
	return t;
}

double getS(vector < pnt > & b) {
	double ans = 0;
	for (int i = 0; i < (int)b.size(); i++) 
		ans += (b[i] * b[(i + 1) % b.size()]);
	return fabs(ans / 2);
}

bool cmpX(pnt a, pnt b) {
	return less(a.x, b.x) || (equal(a.x, b.x) && less(a.y, b.y));
}

int main() {
#ifdef DEBUG
	freopen("in", "r", stdin);
	//freopen("out", "w", stdout);
#endif
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		p[i].read();
		p[i].id = i;
	}
	int nn = n;
	sort(p, p + n, cmpX);
	for (int t = 1;; t++) {
		if (n == 0) break;
		for (int i = 0; i < n; i++)
			p[i].id2 = i;
		int cur1 = 0, cur2 = 0;
		memset(flag, 0, sizeof(flag)); 
		for (int i = 0;	i < n; i++) {
			for (; cur1 >= 2 && less((stack1[cur1 - 1] - stack1[cur1 - 2]) * (p[i] - stack1[cur1 - 1]), 0); cur1--) {
				flag[stack1[cur1 - 1].id2]++;
			}
			stack1[cur1++] = p[i];
		}
		for (int i = n - 1;	i >= 0; i--) {
			for (; cur2 >= 2 && less((stack2[cur2 - 1] - stack2[cur2 - 2]) * (p[i] - stack2[cur2 - 1]), 0); cur2--) {
				flag[stack2[cur2 - 1].id2]++;
			}
			stack2[cur2++] = p[i];
		}
		int cur = 0;	
		for (int i = 0; i < n; i++)
			if (flag[i] == 2)
				p[cur++] = p[i];
		n = cur;
		for (int i = 0; i < cur1; i++)
			answer[stack1[i].id] = t;	
		
		for (int i = 0; i < cur2; i++)
			answer[stack2[i].id] = t;
	}
	for (int i = 0; i < nn; i++)
		printf("%d\n", answer[i]);


	return 0;
}


