#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

struct pt
{
    LL x, y;
    pt() {}
    pt(LL x, LL y) : x(x), y(y) {}

    friend bool operator< (const pt &a, const pt &b)
    {
        return mp(a.x, a.y) < mp(b.x, b.y);
    }

    friend bool operator== (const pt &a, const pt &b)
    {
        return mp(a.x, a.y) == mp(b.x, b.y);
    }

    friend pt operator-(const pt &a, const pt &b)
    {
        return pt(a.x - b.x, a.y - b.y);
    }
};

LL vect(const pt &a, const pt &b, const pt &c)
{
    pt ab = b - a;
    pt ac = c - a;
    return ab.x * ac.y - ab.y * ac.x;
}

int n, m;
vector <pt> a, b;

vector <int> used;
int cnt = 0;

void convex_hull(int cl)
{
    vector <int> h;
    int last = -1;
    for (int i = 0; i < m; i++)
    {
        if (used[i] != -1)
            continue;
        while (h.size() > 1 && vect(a[h[h.size() - 2]], a[h[h.size() - 1]], a[i]) > 0 )
            h.pop_back();
        h.pb(i);
        last = i;
    }
    int sz = h.size();
    for (int i = last - 1; i >= 0; i--)
    {
        if (used[i] != -1)
            continue;
        while (h.size() > sz && vect(a[h[h.size() - 2]], a[h[h.size() - 1]], a[i]) > 0 )
            h.pop_back();
        h.pb(i);
    }
    if (h.size() > 1)
        h.pop_back();
    for (int i = 0; i < h.size(); i++)
        used[h[i]] = cl;
    cnt += h.size();
}

void solve()
{
    scanf("%d", &n);
    b.resize(n);
    for (int i = 0; i < n; i++)
    {
        int x, y;
        scanf("%d %d", &x, &y);
        b[i] = pt(x, y);
    }
    a = b;
    sort(a.begin(), a.end());
    a.erase(unique(a.begin(), a.end()), a.end());
    m = a.size();
    used.resize(m, -1);
    int cl = 1;
    while (cnt < m)
        convex_hull(cl++);

    for (int i = 0; i < n; i++)
    {
        int pos = lower_bound(a.begin(), a.end(), b[i]) - a.begin();
        printf("%d\n", used[pos]);
    }
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif